class Button {
  int x, y; // The x- and y-coordinates
  int width, height; // Dimension (width and height)
  boolean over = false; // True when the mouse is over
  boolean pressed = false; // True when the mouse is over and pressed
  String texto;
  float c = 1.65, b = 3.5;
  int fontsize;
  int lines, cols; // aux counter vars for fontsize determination (from text string)
  boolean show;
  color Color=color(0); //color of the letters
  
  Button(int xp, int yp, int width, int height,String texto, boolean show) {
    x = xp;
    y = yp;
    this.width =  width;
    this.height = height;
    this.texto = texto; 
    this.show = show;
    fontsize = 14;
    //CalculateFont();
  }
    
  void CalculateFont() {    
   String [] TMPBuffer = splitTokens(texto, "\n"); // store BText in temporary var, split in lines, to determine fontsize 
    cols = 0;
    for (lines = 0; lines < TMPBuffer.length; lines++) {
      if (TMPBuffer[lines].length() > cols) cols = TMPBuffer[lines].length();
    }
    fontsize = round(c*width / cols);
    if (fontsize > round(height / lines)) fontsize = round(height/lines);
  }
  
  // Updates the over field every frame
  void update() {
    if ((mouseX >= x-width/2) && (mouseX <= x+width/2) &&
      (mouseY >= y-height/2) && (mouseY <= y+height/2)) {
      over = true;
    } 
    else {
      over = false;
    }
  }
//problemas a vista
  boolean press() {
    if (over == true) {
      pressed = true;
      return true;
    } 
    else {
      return false;
    }
  }

  void release() {
    pressed = false; // Set to false when the mouse is released
    fill(0);
  }

  void display() {
    pushStyle();
   if(show == true){ 
   color shade,light,plateau,selected,TMPcolor;
    
    plateau = TMPcolor = color(#AAAAAA);
    shade = lerpColor(#000000, plateau, 0.8);
    light = lerpColor(#FFFFFF, plateau, 0.8);
    selected = color(255-red(plateau), 255-green(plateau), 255-blue(plateau));
    beginShape(QUADS);
    noStroke();

    if (pressed == true) {
      fill(lerpColor(selected, light, 0.9));
    } 
    else if (over == true) {
     fill(light);
    } 
    else {
      fill(shade);
    }
    vertex(x - (width + b)/2, y - (height + b)/2);
    vertex(x - (width)/2, y - (height)/2);
    vertex(x - (width)/2, y + (height)/2);
    vertex(x - (width + b)/2, y + (height + b)/2);
    
    vertex(x - (width + b)/2, y + (height + b)/2);
    vertex(x - (width)/2, y + (height)/2);
    vertex(x + (width)/2, y + (height)/2);
    vertex(x + (width + b)/2, y + (height + b)/2);
    
   if (pressed == true) {
      fill(lerpColor(selected, shade, 0.9));
    } 
    else if (over == true) {
      fill(shade);
    } 
    else {
      fill(light);
    }
    vertex(x - (width + b)/2, y - (height + b)/2);
    vertex(x - (width)/2, y - (height)/2);
    vertex(x + (width)/2, y - (height)/2);
    vertex(x + (width + b)/2, y - (height + b)/2);
    
    vertex(x + (width + b)/2, y - (height + b)/2);
    vertex(x + (width)/2, y - (height)/2);
    vertex(x + (width)/2, y + (height)/2);
    vertex(x + (width + b)/2, y + (height + b)/2);
    endShape();
    
    if (pressed == true) {
      fill(lerpColor(selected, shade, 0.5));
    } 
    else if (over == true) {
      fill( lerpColor(shade, plateau, 0.7));
    } 
    else {
      fill(plateau);
    }
    rectMode(CENTER);
    rect(x, y, width, height);

 
   if (pressed == true) {
      fill(lerpColor( color((brightness(TMPcolor) > 128) ? (0) : (255)) , TMPcolor, 0.7));
    } 
    else if (over == true) {
      fill(lerpColor( color((brightness(TMPcolor) > 128) ? (0) : (255)) , light, 0.2));
    } 
    else {
      fill(lerpColor( color((brightness(TMPcolor) > 128) ? (0) : (255)) , shade, 0.2));
    }
   }
   
   textAlign(CENTER, CENTER);
   textFont(fontTitle, fontsize);
   textLeading(fontsize);
   fill(Color);
   text(texto, x+c/2, y-b/2);
    //textAlign(LEFT);  
    rectMode(CORNER);
    textFont(f,20);
    popStyle();
}

}

