float Tc = 1043; //Curie Temperature

//ok, gonna create the potential field ferroAngles e ferroX to handle exchange 

void atom(float x, float y, float r,  float magDir, float T, int MagMat, int i, int j, PGraphics pg) {
  //arrow(x, y, r/1.6, magDir);  
  pg.beginDraw();
  pg.fill(255); 
  pg.stroke(0);
  pg.smooth();
  pg.strokeWeight(1);
  if(MagMat==0) pg.fill(226, 234,0, 30);
  if(MagMat==1) pg.fill(230, 30);
  if(MagMat==2) pg.fill(120, 230,100, 30);
 
  pg.ellipse(x, y, r, r);

  //1: Diamagnetic
  if(MagMat ==0) {
    if(mod<1) {
      // mod=0;
    }
    else if((mod>=1)&&(mod<=13)) {
      //  println(magDir); 
      arrow0(x, y,  -r/1.6,(random(-3,3))/(4*mod)+magDir, pg);
      // else arrow(x, y,  r/1.6,magDir + random(0,(60-mod)/30), pg);
    } 
    else {
      arrow0(x, y, -r/1.6,magDir, pg);
    }
  }  
  //0:Paramagnetic   
  if(MagMat == 1) {
    if(mod<1) {
      mod=0;
      arrow(x, y,  r/1.6,random(-3,3)*(particles[i][j].velocity().y())*15+random(-3,3), pg);//arrow(x, y,  r/1.6,random(-particles[i][j].velocity().x()*random(i+j+20)/16,particles[i][j].velocity().x()*random(i+j+20)/16)*T/50, pg);
    }
 
    //I have to implement the curie law
    else if((mod>=1)&&(mod<=11)) {
      //    println(magDir); 
      arrow(x, y,  r/1.6,(random(-3,3)*(particles[i][j].velocity().y())*15+random(-3,3))*T/(1000*mod)+magDir, pg);
      // else arrow(x, y,  r/1.6,magDir + random(0,(60-mod)/30), pg);
    } 
    else {
      arrow(x, y, r/1.6,magDir, pg);
    }
  }

  //2: Ferromagnetic
  if(MagMat == 2) {
    // text(Temp.getPos(), 300,400);
    if(T<Tc) {
      if(mod<5) {
        arrow(x, y,  r/1.6,magDir, pg);
      }
      
      else arrow(x, y,  r/1.6,magDir+0.008*random(0.8*(T/Tc),1.2*(T/Tc)), pg);
    }
   else {
    if(mod<1) {
      mod=0;
      arrow(x, y,  r/1.6,random(-3,3)*(particles[i][j].velocity().y())*15+random(-3,3), pg);//arrow(x, y,  r/1.6,random(-particles[i][j].velocity().x()*random(i+j+20)/16,particles[i][j].velocity().x()*random(i+j+20)/16)*T/50, pg);
    }
 
    //I have to implement the curie law
    else if((mod>=1)&&(mod<=11)) {
      //    println(magDir); 
      arrow(x, y,  r/1.6,(random(-3,3)*(particles[i][j].velocity().y())*15+random(-3,3))*T/(1000*mod)+magDir, pg);
      // else arrow(x, y,  r/1.6,magDir + random(0,(60-mod)/30), pg);
    } 
    else {
      arrow(x, y, r/1.6,magDir, pg);
    }
  }
  }
  pg.endDraw();
}

