void variable(String[] var, String[] explicacao, float x, float y, int f) { 
  //dado uma fórmula guardada num array var e a explicação bonitinha
  //guardada no explicacao, vai escrever na tela a fórmula e, quando o mouse estiver sobre algum termo, sua definição será exibida 
  //os dois vetores devem ter o mesmo tamanho. f é o tamanho da fonte. vai desenhar um vetor em cima da letra caso ela seja precedida por *; faz subscrito de seguida por _
  //Sintaxe: X* => X vetor
  // X^a => X^a, superscrito
  //X_a = X a subscrito
  //X  + => +X 

  pushStyle();
  textSize(f);
  textLeading(f);
  textAlign(LEFT);  
  fill(0);

  for(int i = 0; i <var.length; i++) {
    fill(0);  
    stroke(0);
    if((mouseX>(x+1.5*i*f))&&(mouseX<(x+(1.5*i+1)*f))&&(mouseY>(y-f))&&(mouseY<(y))) {
      text(explicacao[i], x+i*f, y+f);
    }

    if(var[i].length()>1) {


      if(var[i].charAt(1) ==  '*') {
        arrowline(x+(i+0.1)*f, y-f, x+(i+0.8)*f, y-f, g);
      }

      if(var[i].charAt(1) ==  '_') {
        textSize(f/1.5);
        text(var[i].charAt(2), x+(i+0.5)*f,y+f/4);
        textSize(f);
      }

      if(var[i].charAt(1) ==  '^') {
        textSize(f/1.5);
        text(var[i].charAt(2),x+(i+0.5)*f,y-f/2);
        textSize(f);
      }
      if(var[i].length()>3) {
        if((var[i].charAt(3) ==  '+')) {
          text("+"+var[i].charAt(0), x+i*f-f/1.8, y);
        }
        if((var[i].charAt(3) ==  '-')) {
          text("-"+var[i].charAt(0), x+i*f-f/1.8, y);
        }
      }
      else text(var[i].charAt(0), x+i*f, y);
    }
    else   text(var[i].charAt(0), x+i*f, y);
    //detectando mouse
  }    
  popStyle();
}



void variable(String var, String explicacao, float x, float y, int f, float boxPosx, float boxPosy, float boxWidth, float boxHeight) { 
  //dado uma fórmula guardada num array var e a explicação bonitinha
  //guardada no explicacao, vai escrever na tela a fórmula e, quando o mouse estiver sobre algum termo, sua definição será exibida 
  //os dois vetores devem ter o mesmo tamanho. f é o tamanho da fonte. vai desenhar um vetor em cima da letra caso ela seja precedida por *; faz subscrito de seguida por _
  pushStyle();
  textSize(f);
  textLeading(f);
  textAlign(LEFT);  
  fill(0);  
  stroke(0);

  if((mouseX>(x-f))&&(mouseX<(x+f))&&(mouseY>(y-f))&&(mouseY<(y+f))) {
    explicacao(boxPosx, boxPosy, explicacao, boxWidth, boxHeight, f);
     }

  if(var.length()>1) {
    if(var.charAt(1) ==  '*') {
      arrowline(x+(0.1)*f, y-f, x+(0.8)*f, y-f, g);
    }
    if(var.charAt(1) ==  '_') {
      textSize(f/1.5);
      text(var.charAt(2), x+0.6*f,y+f/4);
      textSize(f);
    }

    if(var.charAt(1) ==  '^') {
      textSize(f/1.5);
      text(var.charAt(2),x+(0.5)*f,y-f/2);
      textSize(f);
    }
    
    if(var.length()>3) {
      if((var.charAt(3) ==  '+')) {
        text("+"+var.charAt(0), x-f/1.8, y);
      }
      if((var.charAt(3) ==  '-')) {
        text("-"+var.charAt(0), x-f/1.8, y);
      }
      if(var.charAt(1) ==  '^') {
        text(var.charAt(0), x, y);
      textSize(f/1.5);
      text(var.charAt(2),x+(0.5)*f,y-f/2);
      text(var.charAt(3),x+(0.5)*f,y-f/2);
      textSize(f);
    }  
  }
    
    
    else text(var.charAt(0), x, y);
  }
  else   text(var.charAt(0), x, y);


  // text(var.charAt(0), x, y);
  //detectando mouse 
  popStyle();
}

void explicacao(float xpos, float ypos, String explain, float vwidth, float vheight, int f){ //will create a pop-up to explain some variable; xpos and ypos are the position of the variable; 
    toggleText = true;
    pushStyle();
    //first, this smooth transition, using millis 
    stroke(0);
    fill(150);
    rectMode(CORNER);
    noStroke();
   fill(0,15);
   if(vwidth!=0)   rect(365,280,220,180);
    textSize(12);
    textLeading(12);
    textAlign(LEFT);
    
    fill(0);
    text(explain, xpos+f/6, ypos+f);
    popStyle();
}

